﻿%%SAMPLERFRONT_BINDING%% var samplerFront : sampler;
%%TEXTUREFRONT_BINDING%% var textureFront : texture_2d<f32>;

struct ShaderParams {
	setColor : vec3<f32>,
	intensity : f32,
};
%%SHADERPARAMS_BINDING%% var<uniform> shaderParams : ShaderParams;

%%FRAGMENTINPUT_STRUCT%%
%%FRAGMENTOUTPUT_STRUCT%%

@fragment
fn main(input : FragmentInput) -> FragmentOutput
{
	var front : vec4<f32> = textureSample(textureFront, samplerFront, input.fragUV);
	var col: vec3<f32> = shaderParams.setColor;

	var rgb : vec3<f32> = select(
	2.0 * (col + front.rgb - front.rgb * col) - 1,
	2.0 * front.rgb * col,
	front.rgb < vec3<f32>(0.5)
	);

	var output : FragmentOutput;
	output.color = mix(front, vec4<f32>(rgb, front.a), shaderParams.intensity);
	return output;
}
